# CompuCanvas Simulator
# Written by Linda and Scott Wills
# (c) 2009-2011 Scott & Linda Wills
# All rights reserved.

from Tkinter        import *
from tkMessageBox   import *
from urllib         import urlopen, urlretrieve
from os             import listdir, mkdir, remove, rename
from zipfile        import *

Version = 1.07

CompuCanvasURL = "http://compucanvas.org/"
# CompuCanvasURL = "http://www.ece.gatech.edu/~scotty/compucanvas/"
CompuCanvasZip = "CompuCanvas.zip"

class Manager () :
    """ This class supports installation, upgrading and maintanance, and running
    of CompuCanvas. """
    def __init__(Self, Version, URL) :
        Self.Run = False
        WebVersion = Self.Get_Version(URL)
        BinDir, SchDir = Self.Get_Dirs()
        if WebVersion :
            if BinDir == "../bin/" and Version == WebVersion :
                Self.Run = True
            else :
                urlretrieve(URL + CompuCanvasZip, CompuCanvasZip)
                Zip = ZipFile(CompuCanvasZip, "r")
                if not BinDir :                         # CompuCanvas.py outside ./bin (install)
                    print "installing CompuCanvas ..."
                    Zip.extractall('.')
                    remove("CompuCanvas.py")
                    print "install complete"
                elif Version <> WebVersion :            # CompuCanvas.py inside ./bin (upgrade)
                    print "upgrading CompuCanvas to version %.2f ..." % (WebVersion)
                    if not SchDir :
                        print "creating ../sch ..."
                        mkdir("../sch")
                        SchDir = "../sch/"
                    Zip.extractall("../..")
                    print "upgrade complete"
                Zip.close()
                remove(CompuCanvasZip)
        else :
            print "cannot access CompuCanvas website"
            if BinDir == "../bin/" :
                print "running current version"
                Self.Run = True
            else :
                print "check internet access; if okay, the website must be down; sorry"

    def Get_Version (Self, URL) :
        """ This routine attempts to download the web version number from
        the web. If it fails, the web version number is set to None. """
        try :
            return float(urlopen(URL + 'version.txt').read())
        except IOError :
            return None

    def Get_Dirs(Self) :
        """ This routine returns the bin and sch directories. If they don't exist,
        None is returned. """
        Items = listdir("..")
        BinDir = SchDir = None
        if 'bin' in Items :
            BinDir = '../bin/'
        if 'sch' in Items :
            SchDir = '../sch/'
        return (BinDir, SchDir)

if __name__ == '__main__':
    Mgr = Manager(Version, CompuCanvasURL)
    if Mgr.Run :
        from UserInterface import *
        Main = CompuCanvas(Version)
        Main.mainloop()
